﻿using Microsoft.AspNetCore.Mvc;
using TECIT.TBarCode;
using System.Drawing;
using static System.Net.Mime.MediaTypeNames;
using System.Runtime.Versioning;
using System.Drawing.Imaging;

namespace ASPNETCoreWebApp
{
    [SupportedOSPlatform("windows")]
    public class BarcodeController : Controller
    {

        // 
        // GET: /Barcode/
        public string Index()
        {
            return "Please specifiy the action parameter...";
        }

        // 
        // GET: /Barcode/GetQRCodeImg/ 
        public FileResult GetQRCodeImg(string data)
        {
            Barcode code = new Barcode();
            code.BarcodeType = BarcodeType.QRCode;
            code.Data = data;

            try
            {
                Size bitmapSize = code.CalculateOptimalBitmapSize(null, 4, 4);
                code.BoundingRectangle = new Rectangle(0, 0, bitmapSize.Width, bitmapSize.Height);

                using (Bitmap qrCodeImage = code.DrawBitmap())
                {
                    var ms = new MemoryStream();
                    qrCodeImage.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
                    //ms.Position = 0;

                    byte[] imageData = ms.ToArray();
                    return File(imageData, "image/png");
                }
            }
            catch (Exception ex)
            {
                // Write message as text for debugging purposes.
                using (var ms = new MemoryStream())
                {
                    var sw = new StreamWriter(ms);
                    sw.WriteLine(ex.Message);
                    sw.Flush();
                    sw.Close();
                    return File(ms.ToArray(), "text/plain");
                }
            }
        }


        // 
        // GET: /Barcode/GetQRCodeImgNoGDI/ 
        public FileResult GetQRCodeImgNoGDI(string data)
        {
            Barcode code = new Barcode();
            code.BarcodeType = BarcodeType.QRCode;
            code.Data = data;

            try
            {
                Size bitmapSize = code.CalculateOptimalBitmapSize(null, 4, 4);
                code.BoundingRectangle = new Rectangle(0, 0, bitmapSize.Width, bitmapSize.Height);

                var noGDI = new BarcodeNoGDI(code); // see constructor for Licensing!
                using (var ms = new MemoryStream())
                {
                    noGDI.GenerateAsBitmap(ms, System.Drawing.Imaging.ImageFormat.Png);

                    byte[] imageData = ms.ToArray();
                    return File(imageData, "image/png");
                }
            }
            catch (Exception ex)
            {
                // Write message as text for debugging purposes.
                using (var ms = new MemoryStream())
                {
                    var sw = new StreamWriter(ms);
                    sw.WriteLine(ex.Message);
                    sw.Flush();
                    sw.Close();
                    return File(ms.ToArray(), "text/plain");
                }
            }
        }
    }
}
